// PgTweaks.cpp : implementation file
//

#include "wintypes.h"
#include "amule.h"
#include "PPgTweaks.h"
#include "muuli_wdr.h"

#include <wx/slider.h>
#include <wx/notebook.h>
#include <wx/checkbox.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgTweaks dialog

IMPLEMENT_DYNAMIC_CLASS(CPPgTweaks,wxPanel)

BEGIN_EVENT_TABLE(CPPgTweaks,wxPanel)
	EVT_SCROLL(CPPgTweaks::OnHScroll)
END_EVENT_TABLE()

CPPgTweaks::CPPgTweaks(wxWindow* parent)
: wxPanel(parent,CPPgTweaks::IDD)
{
	wxNotebook* book=(wxNotebook*)parent;

	wxSizer* page1=PreferencesaMuleTweaksTab(this,TRUE);
	book->AddPage(this,_("Tweaks"));
  
	m_iFileBufferSize = 0;
}

CPPgTweaks::~CPPgTweaks()
{
}

// CPPgTweaks message handlers

BOOL CPPgTweaks::OnInitDialog()
{
	return TRUE;
}


void CPPgTweaks::LoadSettings(void)
{
	CString strBuffer;

	strBuffer.Format("%d", app_prefs->GetMaxConperFive());
	((wxSpinCtrl*)FindWindowById(IDC_MAXCON5SEC))->SetValue(strBuffer);

	if(app_prefs->prefs->m_bVerbose) {
		((wxCheckBox*)FindWindowById(IDC_VERBOSE))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_VERBOSE))->SetValue(FALSE);
	}
	
	if(app_prefs->prefs->showRatesInTitle) {
		((wxCheckBox*)FindWindowById(IDC_SHOWRATEONTITLE))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_SHOWRATEONTITLE))->SetValue(FALSE);
	}

	if(app_prefs->prefs->m_bupdatequeuelist) {
		((wxCheckBox*)FindWindowById(IDC_UPDATEQUEUE))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_UPDATEQUEUE))->SetValue(FALSE);
	}

	if(app_prefs->prefs->autotakeed2klinks) {
		((wxCheckBox*)FindWindowById(IDC_AUTOTAKEED2KLINKS))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_AUTOTAKEED2KLINKS))->SetValue(FALSE);
	}

	((wxSlider*)FindWindowById(IDC_FILEBUFFERSIZE))->SetValue(app_prefs->prefs->m_iFileBufferSize);
	m_iFileBufferSize = app_prefs->prefs->m_iFileBufferSize;
	((wxSlider*)FindWindowById(IDC_QUEUESIZE))->SetValue(app_prefs->prefs->m_iQueueSize);
	m_iQueueSize = app_prefs->prefs->m_iQueueSize;

	// must fake two scroll events.. setvalue won't cause any events
	wxScrollEvent evt1(0,IDC_QUEUESIZE,app_prefs->prefs->m_iQueueSize);
	evt1.SetEventObject((wxSlider*)FindWindowById(IDC_QUEUESIZE));
	OnHScroll(evt1);

	wxScrollEvent evt2(0,IDC_FILEBUFFERSIZE,app_prefs->prefs->m_iFileBufferSize);
	evt2.SetEventObject((wxSlider*)FindWindowById(IDC_FILEBUFFERSIZE));
	OnHScroll(evt2);
}

BOOL CPPgTweaks::OnApply()
{
	app_prefs->SetMaxConsPerFive(((wxSpinCtrl*)FindWindowById(IDC_MAXCON5SEC))->GetValue());

	if (((wxCheckBox*)FindWindowById(IDC_VERBOSE))->IsChecked()) {
		app_prefs->prefs->m_bVerbose = true;
	} else {
		app_prefs->prefs->m_bVerbose = false;
	}

	if (((wxCheckBox*)FindWindowById(IDC_UPDATEQUEUE))->IsChecked()) {
		app_prefs->prefs->m_bupdatequeuelist = true;
	} else {
		app_prefs->prefs->m_bupdatequeuelist = false;
	}

	if (((wxCheckBox*)FindWindowById(IDC_SHOWRATEONTITLE))->IsChecked()) {
		app_prefs->prefs->showRatesInTitle= true;
	} else {
		app_prefs->prefs->showRatesInTitle= false;
	}

	app_prefs->prefs->autotakeed2klinks = (int8)(((wxCheckBox*)FindWindowById(IDC_AUTOTAKEED2KLINKS))->IsChecked());
	app_prefs->prefs->m_iFileBufferSize = m_iFileBufferSize;
	app_prefs->prefs->m_iQueueSize = m_iQueueSize;

	if (!theApp.glob_prefs->ShowRatesOnTitle()) {
		// sprintf(buffer,"aMule %s",CURRENT_VERSION_LONG);
		// theApp.amuledlg->SetWindowText(buffer);
	}

	return TRUE;
}

void CPPgTweaks::OnHScroll(wxScrollEvent& evt)
{
	wxSlider* slider=(wxSlider*)evt.GetEventObject();
	CString temp;
	if (slider==((wxSlider*)FindWindowById(IDC_FILEBUFFERSIZE))) {
		m_iFileBufferSize = evt.GetPosition();
		temp.Format("File Buffer Size (%i)", m_iFileBufferSize*15000 );
		((wxSlider*)FindWindowById(IDC_FILEBUFFERSIZE_STATIC))->SetLabel(temp);
	} else if (slider==((wxSlider*)FindWindowById(IDC_QUEUESIZE))) {
		m_iQueueSize = evt.GetPosition();
		temp.Format("Queue Size (%i)", m_iQueueSize*100 );
		((wxSlider*)FindWindowById(IDC_QUEUESIZE_STATIC))->SetLabel(temp);
	}

}

void CPPgTweaks::Localize(void)
{	
}
